unit Misc;

interface
uses dos,strings;
  const
    CheckError: boolean = FALSE;

  function AsciiTime:string;

  function Min(x, y: longint): longint;

  function Max(x, y: longint): longint;

  function LowCase(c: char): char;

  function Whole(x: longint; width: shortint): string;

  procedure SetBase(b: shortint);

  procedure writex(ss:string);

  function IncR(var y: integer): integer;
  inline($5f/$07/$26/$ff/$05/$26/$8b/$05);

  function RInc(var y: integer): integer;
  inline($5f/$07/$26/$8b/$05/$26/$ff/$05);

  function DecR(var y: integer): integer;
  inline($5f/$07/$26/$ff/$0d/$26/$8b/$05);

  function RDec(var y: integer): integer;
  inline($5f/$07/$26/$8b/$05/$26/$ff/$0d);

  procedure Assert(b: boolean; msg: string);

  procedure Stop;
  inline($eb/$fe);

  procedure Check(b: boolean; msg: string);

  procedure ClearCheck;

	function hexb(w:byte):string;
	function hexw(w:word):string;
	function hexd(w:longint):string;
	function hexp(w:longint):string;


implementation

  function Min(x, y: longint): longint;
  begin
    if x>y then Min:=y
    else Min:=x
  end {Min};

  function Max(x, y: longint): longint;
  begin
    if x>y then Max:=x
    else Max:=y
  end {Max};

  function LowCase(c: char): char;
  begin
    if c IN ['A'..'Z'] then LowCase:=Chr(Ord(c)+32)
    else LowCase:=c
  end {LowCase};

  const
    InitBase: byte = 10;
    InitBlank: char = ' ';

  var
    Base: byte absolute InitBase;
    Blank: char absolute InitBlank;

  function Whole(x: longint; width: shortint): string;
    const
      digit: array [0..35] of char =
               '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    var
      i, j: integer;
      wp, xn: boolean;
      s: string[130];
  begin
    wp:=(width>0); width:=Abs(width);
    xn:=(x<0); x:=Abs(x);
    s:='';
    repeat
      s:=digit[x MOD Base]+s; x:=x DIV Base
    until x=0;
    j:=2;
    if xn then s:='-'+s
    else if wp then s:='+'+s
    else j:=1;
    if Blank=' ' then j:=1;
    for i:=Length(s)+1 to width do
      Insert(Blank, s, j);
    Whole:=s
  end {Whole};

  procedure SetBase(b: shortint);
  begin
    if Abs(b) IN [2..36] then begin
      Base:=Abs(b);
      Blank:=' ';
      if b<0 then Blank:='0';
    end
  end {SetBase};

  procedure Assert(b: boolean; msg: string);
  begin
    if NOT b then begin
      WriteLn;
      WriteLn('*** Assert error *** - ', msg);
      Halt
    end
  end {Assert};

  var
    ChErr: boolean absolute CheckError;

  procedure Check(b: boolean; msg: string);
  begin
    if NOT b then begin
      WriteLn;
      WriteLn('*** Error *** - ', msg);
      ChErr:=TRUE
    end
  end {Check};

  procedure ClearCheck;
  begin
    ChErr:=FALSE
  end {Check};

function hexw(w:word):string;
var s:string[5];
j,i:byte;
begin
s:='';
s[0]:=#4;
for i:= 0 to 3 do begin
j:=(w and $f) + $30;
if j > $39 then j := j+7;
s[4-i]:=chr(j);
w := w shr 4;
end;
hexw:=s;
end;

function hexd(w:longint):string;
var s:string[9];
j,i:byte;
begin
s:='';
s[0]:=#8;
for i:= 0 to 7 do begin
j:=(w and $f) + $30;
if j > $39 then j := j+7;
s[8-i]:=chr(j);
w := w shr 4;
end;
hexd:=s;
end;

function hexp(w:longint):string;
var s:string[10];
w1,w2:word;
begin
asm
mov	ax,word ptr w
mov	dx,word ptr [w+2]
mov	word ptr w1,dx
mov	word ptr w2,ax
end;
s:=hexw(w1)+':'+hexw(w2);
hexp:=s;
end;

function hexb(w:byte):string;
var s:string[3];
j,i:byte;
begin
s:='';
s[0]:=#2;
for i:= 0 to 1 do begin
j:=(w and $f) + $30;
if j > $39 then j := j+7;
s[2-i]:=chr(j);
w := w shr 4;
end;
hexb:=s;
end;


function AsciiTime:string;
var
h, m, s, hund :word;
dd:string[20];

function LZ(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LZ := s;
end;

begin
  GetTime(h, m, s, hund);
  dd:=Lz(h)+':'+Lz(m)+' ';
  GetDate(h, m, s, hund);
  AsciiTime:=dd+Lz(s)+'.'+Lz(m)+'.'+Lz(h);
end;


procedure writex(ss:string);
var
y1,yy:word;
z3:char;
t5:integer;
begin
	yy:=strlen(@ss);
	for y1:=1 to yy do begin
		z3:=ss[y1];
		asm
		mov	ah, 02h
		mov	dl, z3
		int 21h
		end;
	end;

end;


end {Misc}.
